#include "ChangeSizePanel.hpp"

ChangeSizePanel::ChangeSizePanel(WindowManager* wm_) : Window(wm_),
    space(8), fontHeight(IDISPLAY_GetFontMetrics(wm->display, AEE_FONT_NORMAL, NULL, NULL)),
    cursor(0) {

    wm_->softkeyWindow->setText("߂", "", "I");
    ISHELL_CreateInstance(wm_->shell, AEECLSID_TEXTCTL, (void**)&widthTextBox);
    const AEERect rect = {100, space, 80, fontHeight};
    ITEXTCTL_SetRect(widthTextBox, &rect);
    AECHAR buf[10];
    AECHAR format[] = {'%', 'd', '\0'};
    WSPRINTF(buf, sizeof(buf), format, wm_->lifeGame->getWidth());
    ITEXTCTL_SetText(widthTextBox, buf, WSTRLEN(buf));

    ISHELL_CreateInstance(wm_->shell, AEECLSID_TEXTCTL, (void**)&heightTextBox);
    const AEERect rect2 = {100, fontHeight + space * 2, 80, fontHeight};
    ITEXTCTL_SetRect(heightTextBox, &rect2);
    WSPRINTF(buf, sizeof(buf), format, wm_->lifeGame->getHeight());
    ITEXTCTL_SetText(heightTextBox, buf, WSTRLEN(buf));

    paint();
}

ChangeSizePanel::~ChangeSizePanel() {
    ITEXTCTL_Release(widthTextBox);
    ITEXTCTL_Release(heightTextBox);
}

void ChangeSizePanel::paint() {
    IGraphics* graphic;
    // IGraphics IuWFNg̎擾
    ISHELL_CreateInstance(wm->shell, AEECLSID_GRAPHICS, (void**)&graphic);
    IGRAPHICS_SetBackground(graphic, 255, 255, 255);
    IGRAPHICS_ClearViewport(graphic);

    DrawText(wm->display, "Width :", 15, space);
    DrawText(wm->display, "Height:", 15, fontHeight + space * 2);
    DrawText(wm->display, "Set", 15, fontHeight * 2 + space * 3);

    ITEXTCTL_Redraw(widthTextBox);
    ITEXTCTL_Redraw(heightTextBox);

    DrawRect(wm->display, 100, space, 80, fontHeight, MAKE_RGB(0, 0, 0));
    DrawRect(wm->display, 100, fontHeight + space * 2, 80, fontHeight, MAKE_RGB(0, 0, 0));
    DrawRect(wm->display, 15, fontHeight * 2 + space * 3, 50, fontHeight, MAKE_RGB(0, 0, 0));
    switch (cursor) {
	    case 0:
		    DrawRect(wm->display, 100-2, space-2, 80+4, fontHeight+4, MAKE_RGB(255, 0, 0));
		    break;
	    case 1:
		    DrawRect(wm->display, 100-2, fontHeight + space * 2-2, 80+4, fontHeight+4, MAKE_RGB(255, 0, 0));
		    break;
	    case 2:
		    DrawRect(wm->display, 15-2, fontHeight * 2 + space * 3-2, 50+4, fontHeight+4, MAKE_RGB(255, 0, 0));
		    break;
    }
    wm->update(wm->display);
}

void ChangeSizePanel::keyPress(uint16 key) {
    if (wm->textCtl1 != NULL) {
        ITEXTCTL_SetActive(widthTextBox, false);
        wm->textCtl1 = NULL;
        paint();
        return;
    }
    if (wm->textCtl2 != NULL) {
        ITEXTCTL_SetActive(heightTextBox, false);
        wm->textCtl2 = NULL;
        paint();
        return;
    }
	switch(key) {
	    case AVK_DOWN:
		    if (cursor < 2) {
			    cursor++;
			    paint();
		    }
		    break;
	    case AVK_UP:
		    if (cursor > 0) {
			    cursor--;
			    paint();
		    }
		    break;
	    case AVK_SELECT:
		    switch (cursor) {
		    case 0:
                ITEXTCTL_SetActive(widthTextBox, true);
                wm->textCtl1 = widthTextBox;
			    break;
		    case 1:
                ITEXTCTL_SetActive(heightTextBox, true);
                wm->textCtl2 = heightTextBox;
			    break;
            case 2:
                {
                    char buf[10];
                    WSTRTOSTR(ITEXTCTL_GetTextPtr(widthTextBox), buf, sizeof(buf));
                    int width = ATOI(buf);
                    WSTRTOSTR(ITEXTCTL_GetTextPtr(heightTextBox), buf, sizeof(buf));
                    int height = ATOI(buf);
                    if (2 < width && 2 < height) {
                        wm->lifeGame->setSize(width, height);
                    }
                }
                wm->changeState(STATE_TITLE);
			    break;
            }
            break;
        case AVK_SOFT1:
            wm->changeState(STATE_TITLE);
            break;
	    case AVK_SOFT2:
		    ISHELL_CloseApplet(wm->shell, FALSE);
		    break;
    }
}
