#ifndef __LIFEGAMEDATA_HPP
#define __LIFEGAMEDATA_HPP

#include "BPPLib.hpp"
#include "LifeGame.hpp"
#include "AEEFILE.h"

#define FILENAME_PREFIX "data/data"
#define FILENAME_POSTFIX ".txt"

class LifeGameData {
private:
    BPPString name;
    int width;
    int height;
    Matrix matrix;

public:
    LifeGameData() {};
    LifeGameData(BPPString& name_, Matrix& matrix_){
        name = name_;
        matrix = matrix_;
        width = matrix.getWidth();
        height = matrix.getHeight();
    }
    LifeGameData(int index, IShell* shell);

    BPPString getName() { return name; }
    void setName(BPPString& name_) { name = name_; }
    Matrix& getMatrix() { return matrix; }
    
    void write(int index, IShell* shell);
};

#endif //__LIFEGAMEDATA_HPP
