#include "LifeGameEditCanvas.hpp"
#include "LifeGameApp.hpp"

#include "BPPLib.hpp"

LifeGameEditCanvas::LifeGameEditCanvas(WindowManager* wm_)
    : Window(wm_), cursorX(1), cursorY(1), matrix(wm->lifeGame->getMatrix()) {

    wm->softkeyWindow->setText("XV", "", "I");
    paint();
}

void LifeGameEditCanvas::paint() {
    IGraphics* graphic;
    // IGraphics IuWFNg̎擾
    ISHELL_CreateInstance(wm->shell, AEECLSID_GRAPHICS, (void**)&graphic);
    IGRAPHICS_SetBackground(graphic, 255, 255, 255);
    IGRAPHICS_ClearViewport(graphic); //ʂ

    wm->lifeGame->paint(wm->display);
    DrawRect(wm->display, cursorY * LifeGame::CELL_WIDTH, cursorX * LifeGame::CELL_HEIGHT,
        LifeGame::CELL_WIDTH-1, LifeGame::CELL_HEIGHT-1, MAKE_RGB(0, 255, 0));

    wm->update(wm->display);
}
    
void LifeGameEditCanvas::keyPress(uint16 key)
{
    switch(key) {
    case AVK_DOWN:
        if(cursorX < matrix.getWidth()-2){
            cursorX++;
        } else{
            cursorX = 1;
        }
        paint();
        break;
    case AVK_UP:
        if(cursorX > 1){
            cursorX--;
        } else{
            cursorX = matrix.getWidth()-2;
        }
        paint();
        break;
    case AVK_LEFT:
        if(cursorY > 1){
            cursorY--;
        } else{
            cursorY = matrix.getHeight()-2;
        }
        paint();
        break;
    case AVK_RIGHT:
        if(cursorY < matrix.getHeight()-2){
            cursorY++;
        } else{
            cursorY = 1;
        }
        paint();
        break;
    case AVK_SELECT:
        matrix.reverseCell(cursorY, cursorX);
        paint();
        break;
    case AVK_SOFT1:
        wm->changeState(STATE_TITLE);
        break;
    case AVK_SOFT2:
        ISHELL_CloseApplet(wm->shell, FALSE);
        break;
    }
    return;
}
