#include "LifeGameMainCanvas.hpp"
#include "LifeGameApp.hpp"
#include "AEEGraphics.h"

#define TIMER_INTERVAL 300

LifeGameMainCanvas::LifeGameMainCanvas(WindowManager* wm_) : Window(wm_) {
    //^C}[̃Zbg
    ISHELL_SetTimer(wm->shell, TIMER_INTERVAL, LifeGameMainCanvas::OnTimerEntry, this);
    wm->softkeyWindow->setText("߂", "", "I");
    paint();
}

LifeGameMainCanvas::~LifeGameMainCanvas() {
    //^C}[̃LZ
    ISHELL_CancelTimer(wm->shell, LifeGameMainCanvas::OnTimerEntry, this);
}

void LifeGameMainCanvas::paint() {
    IGraphics* graphic;

    // IGraphics IuWFNg̎擾
    ISHELL_CreateInstance(wm->shell, AEECLSID_GRAPHICS, (void**)&graphic);
    IGRAPHICS_SetBackground(graphic, 255, 255, 255);
    IGRAPHICS_ClearViewport(graphic);
    wm->lifeGame->paint(wm->display);

    wm->update(wm->display);
}

void LifeGameMainCanvas::keyPress(uint16 key) {
    switch(key) {
    case AVK_SOFT1:
        wm->changeState(STATE_TITLE);
        break;
    case AVK_SOFT2:
        ISHELL_CloseApplet(wm->shell, FALSE);
        break;
    }
    return;
}

void LifeGameMainCanvas::OnTimerEntry(void* data) {
    ((LifeGameMainCanvas*)data)->next();
}

void LifeGameMainCanvas::next(){
    wm->lifeGame->next(); //CtQ[Pi߂B
    paint();
    //^C}[̍ăZbg
    ISHELL_SetTimer(wm->shell, TIMER_INTERVAL, LifeGameMainCanvas::OnTimerEntry, this);
}
