#include "LifeGameMainPanel.hpp"

#include "AEEGraphics.h"

#include "BPPLib.hpp"

LifeGameMainPanel::LifeGameMainPanel(WindowManager* appli_) : Window(appli_)
{
    cursor = 0;
    wm->softkeyWindow->setText("", "", "I");
    paint();
}

void LifeGameMainPanel::paint()
{
    IGraphics* graphic;

    // IGraphics IuWFNg̎擾
    ISHELL_CreateInstance(wm->shell, AEECLSID_GRAPHICS, (void**)&graphic);
    IGRAPHICS_SetBackground(graphic, 255, 255, 255);
    IGRAPHICS_ClearViewport(graphic); //ʂ

    //tHg̍擾
    const int height = IDISPLAY_GetFontMetrics(wm->display, AEE_FONT_NORMAL, NULL, NULL);
    const int space = 6;
    DrawText(wm->display, "Life Game", 15, space);
    DrawText(wm->display, "Start", 15, height + space * 2);
    DrawText(wm->display, "Edit", 15, height * 2 + space * 3);
    DrawText(wm->display, "Save", 15, height * 3 + space * 4);
    DrawText(wm->display, "Load", 15, height * 4 + space * 5);
    DrawText(wm->display, "Change size", 15, height * 5 + space * 6);

    DrawRect(wm->display, 13, height + space * 2, 80, height, MAKE_RGB(0, 0, 0));
    DrawRect(wm->display, 13, height * 2 + space * 3, 80, height, MAKE_RGB(0, 0, 0));
    DrawRect(wm->display, 13, height * 3 + space * 4, 80, height, MAKE_RGB(0, 0, 0));
    DrawRect(wm->display, 13, height * 4 + space * 5, 80, height, MAKE_RGB(0, 0, 0));
    DrawRect(wm->display, 13, height * 5 + space * 6, 140, height, MAKE_RGB(0, 0, 0));

    int dx = 80 + 4;
    if (cursor == 4) dx = 140+4;
    DrawRect(wm->display,
        13-2, (height + space) * (cursor + 1) + space -2, dx, height+4,
        MAKE_RGB(255, 0, 0));

    wm->update(wm->display);
}

void LifeGameMainPanel::keyPress(uint16 key)
{
    switch(key) {
    case AVK_DOWN:
        if (cursor < 4) {
            cursor++;
            paint();
        }
        break;
    case AVK_UP:
        if (cursor > 0) {
            cursor--;
            paint();
        }
        break;
    case AVK_SELECT:
        switch (cursor) {
        case 0:
            wm->changeState(STATE_GAMESTART);
            break;
        case 1:
            wm->changeState(STATE_EDIT);
            break;
        case 2:
            wm->changeState(STATE_SAVE);
            break;
        case 3:
            wm->changeState(STATE_LOAD);
            break;
        case 4:
            wm->changeState(STATE_CHANGESIZE);
            break;
        }
        break;
    case AVK_SOFT2:
        ISHELL_CloseApplet(wm->shell, FALSE);
        break;
    }
}
