#include "LoadPanel.hpp"

LoadPanel::LoadPanel(WindowManager* wm_) : MemoryPanel(wm_) {
    load();
    wm->softkeyWindow->setText("߂", "", "I");
    list = new ListBox(wm, 13, space * 2 + fontHeight, 160, fontHeight * 4, fontHeight);

    for(int i = 0 ; i < len ; i++){
        BPPString string(data[i]->getName());
        list->append(string);
    }

    paint();
}

void LoadPanel::paint()
{
    IGraphics* graphic;
    // IGraphics IuWFNg̎擾
    ISHELL_CreateInstance(wm->shell, AEECLSID_GRAPHICS, (void**)&graphic);
    IGRAPHICS_SetBackground(graphic, 255, 255, 255);
    IGRAPHICS_ClearViewport(graphic);

    DrawText(wm->display, "load from where?", 15, space);
    DrawText(wm->display, "load", 15, fontHeight * 5 + space * 3);

    DrawRect(wm->display, 13, fontHeight * 5 + space * 3, 50, fontHeight, MAKE_RGB(0, 0, 0));
	list->paint();
    if (!list->IsFocus()) {
		switch (cursor) {
			case 0:
				DrawRect(wm->display, 13-2, fontHeight + space * 2-2, 160+4, fontHeight * 4+4, MAKE_RGB(255, 0, 0));
				break;
			case 1:
				DrawRect(wm->display, 13-2, fontHeight * 5 + space * 3-2, 50+4, fontHeight+4, MAKE_RGB(255, 0, 0));
				break;
		}
	}

    wm->update(wm->display);
}

void LoadPanel::keyPress(uint16 key)
{
    if (list->IsFocus()) {
        if (!list->keyPress(key)) {
            wm->softkeyWindow->setText("߂", "", "I");
            paint();
        }
	} else {
		switch(key) {
		case AVK_DOWN:
			if (cursor < 1) {
				cursor++;
				paint();
			}
			break;
		case AVK_UP:
			if (cursor > 0) {
				cursor--;
				paint();
			}
			break;
		case AVK_SELECT:
			switch (cursor) {
			case 0:
                list->SetFocus();
				wm->softkeyWindow->setText("I", "", "");
				paint();
				break;
            case 1:
                wm->lifeGame->setMatrix(data[list->getSelectedIndex()]->getMatrix());
                wm->changeState(STATE_TITLE);
			}
			break;
        case AVK_SOFT1:
            wm->changeState(STATE_TITLE);
            break;
		case AVK_SOFT2:
			ISHELL_CloseApplet(wm->shell, FALSE);
			break;
		}
	}
}
