#ifndef __MEMORYPANEL_HPP
#define __MEMORYPANEL_HPP

#include "LifeGame.hpp"
#include "LifeGameData.hpp"
#include "SoftKeyWindow.hpp"

#define CONFIG_FILENAME "data/config.txt"

class MemoryPanel : public Window {
protected:
    LifeGameData** data;
    int len;
    const int space;
    const int fontHeight;

    MemoryPanel(WindowManager* wm_) : Window(wm_), space(8), 
        fontHeight(IDISPLAY_GetFontMetrics(wm->display, AEE_FONT_NORMAL, NULL, NULL)) {
        ;
    }
    void load();
    void save();
};

class ListBox {
private:
	WindowManager* wm;
	BPPString data[32];
	int length;
	int listTop;
	int listCursor;
	int listSelect;
	int x, y, dx, dy, height;
    bool isFocus;
public:
	ListBox(WindowManager* wm_, int x_, int y_, int dx_, int dy_, int height_);
	void append(BPPString& name);
	void paint();
    bool keyPress(uint16 key);
    void SetFocus() {isFocus = true; }
    bool IsFocus() { return isFocus; }
    int getSelectedIndex() { return listSelect; }
};

#endif //__MEMORYPANEL_HPP
