#include "SavePanel.hpp"
#include "BPPLib.hpp"

BPPString AECHARToBPPString(AECHAR* aechar);

SavePanel::SavePanel(WindowManager* wm_) : MemoryPanel(wm_), cursor(0) {
	load();
    wm->softkeyWindow->setText("߂", "", "I");
    list = new ListBox(wm, 13, space * 2 + fontHeight, 160, fontHeight * 4, fontHeight);
    for (int i = 0 ; i < len ; i++) {
        BPPString string(data[i]->getName());
        list->append(string);
    }
    BPPString string2("new place");
    list->append(string2);
    ISHELL_CreateInstance(wm_->shell, AEECLSID_TEXTCTL, (void**)&textCtl);
    const AEERect rect = {13, fontHeight * 6 + space * 4, 160, fontHeight};
    ITEXTCTL_SetRect(textCtl, &rect);
    paint();
}

SavePanel::~SavePanel() {
    ITEXTCTL_Release(textCtl);
}

void SavePanel::paint()
{
    IGraphics* graphic;
    // IGraphics IuWFNg̎擾
    ISHELL_CreateInstance(wm->shell, AEECLSID_GRAPHICS, (void**)&graphic);
    IGRAPHICS_SetBackground(graphic, 255, 255, 255);
    IGRAPHICS_ClearViewport(graphic);

    DrawText(wm->display, "where?", 15, space);
    DrawText(wm->display, "New name?", 15, fontHeight * 5 + space * 3);
    DrawText(wm->display, "save", 15, fontHeight * 7 + space * 5);
    DrawText(wm->display, "remove", 125, fontHeight * 7 + space * 5);
    DrawText(wm->display, "rename", 15, fontHeight * 8 + space * 6);

    ITEXTCTL_Redraw(textCtl);

    DrawRect(wm->display, 13, fontHeight * 6 + space * 4, 160, fontHeight, MAKE_RGB(0, 0, 0));
    DrawRect(wm->display, 13, fontHeight * 7 + space * 5, 80, fontHeight, MAKE_RGB(0, 0, 0));
    DrawRect(wm->display, 125, fontHeight * 7 + space * 5, 80, fontHeight, MAKE_RGB(0, 0, 0));
    DrawRect(wm->display, 13, fontHeight * 8 + space * 6, 80, fontHeight, MAKE_RGB(0, 0, 0));
	list->paint();
    if (!list->IsFocus()) {
		switch (cursor) {
			case 0:
				DrawRect(wm->display, 13-2, fontHeight + space * 2-2, 160+4, fontHeight * 4+4, MAKE_RGB(255, 0, 0));
				break;
			case 1:
				DrawRect(wm->display, 13-2, fontHeight * 6 + space * 4-2, 160+4, fontHeight+4, MAKE_RGB(255, 0, 0));
				break;
			case 2:
				DrawRect(wm->display, 13-2, fontHeight * 7 + space * 5-2, 80+4, fontHeight+4, MAKE_RGB(255, 0, 0));
				break;
			case 3:
				DrawRect(wm->display, 125-2, fontHeight * 7 + space * 5-2, 80+4, fontHeight+4, MAKE_RGB(255, 0, 0));
				break;
			case 4:
				DrawRect(wm->display, 13-2, fontHeight * 8 + space * 6-2, 80+4, fontHeight+4, MAKE_RGB(255, 0, 0));
				break;
		}
	}

    wm->update(wm->display);
}

void SavePanel::keyPress(uint16 key)
{
    if (wm->textCtl1 != NULL) {
        ITEXTCTL_SetActive(textCtl, false);
        wm->textCtl1 = NULL;
        paint();
        return;
    }
    if (list->IsFocus()) {
        if (!list->keyPress(key)) {
            wm->softkeyWindow->setText("߂", "", "I");
            paint();
        }
	} else {
		switch(key) {
		case AVK_DOWN:
			if (cursor < 4) {
				cursor++;
				paint();
			}
			break;
		case AVK_UP:
			if (cursor > 0) {
				cursor--;
				paint();
			}
			break;
		case AVK_SELECT:
			switch (cursor) {
			case 0:
                list->SetFocus();
				wm->softkeyWindow->setText("I", "", "");
				paint();
				break;
			case 1:
                ITEXTCTL_SetActive(textCtl, true);
                wm->textCtl1 = textCtl;
				break;
			case 2:
                if (list->getSelectedIndex() == len) {
                    BPPString name(AECHARToBPPString(ITEXTCTL_GetTextPtr(textCtl)));
                    data[len] = new LifeGameData(name, wm->lifeGame->getMatrix());
                    len++;
                }
                save();
                wm->changeState(STATE_TITLE);
				break;
			case 3:
                for(int i = list->getSelectedIndex() ; i < len - 1 ; i++){
                    data[i] = data[i+1];
                }
                len--;
                save();
                wm->changeState(STATE_TITLE);
				break;
			case 4:
                if(list->getSelectedIndex() != len){
                    BPPString name(AECHARToBPPString(ITEXTCTL_GetTextPtr(textCtl)));
                    data[list->getSelectedIndex()]->setName(name);
                }
                save();
                wm->changeState(STATE_TITLE);
                break;
			}
			break;
        case AVK_SOFT1:
            wm->changeState(STATE_TITLE);
            break;
		case AVK_SOFT2:
			ISHELL_CloseApplet(wm->shell, FALSE);
			break;
		}
	}
}

BPPString AECHARToBPPString(AECHAR* aechar) {
    AChar* buf = new char[WSTRLEN(aechar) + 1];
    int ip = 0;
    AECHAR c;
    for (; *aechar != '\0' ; aechar++) {
        c = *aechar;
        if (((c >> 8) & 0x00FF) == 0) {
            buf[ip++] = (unsigned char)(c & 0x00FF);
        } else {
            buf[ip++] = (unsigned char)(c & 0x00FF);
            buf[ip++] = (unsigned char)((c >> 8) & 0x00FF);
        }
    }
    buf[ip++] = '\0';
    BPPString ret(buf);
    delete buf;
    return ret;
}
